/*******************************************************************************
 * Copyright (c) 2004-2006 Sybase, Inc.
 * 
 * All rights reserved. This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License v1.0 which
 * accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: Sybase, Inc. - initial API and implementation
 ******************************************************************************/
package org.eclipse.stp.soas.internal.deploy.emf;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;

/**
 * @author rcernich
 * 
 * Created on Feb 24, 2004
 */
public class AdapterFactoryContentProvider extends
		org.eclipse.emf.edit.ui.provider.AdapterFactoryContentProvider {

	/**
	 * @param adapterFactory
	 */
	public AdapterFactoryContentProvider(AdapterFactory adapterFactory) {
		super(adapterFactory);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * Use our NotifyChangedToViewerRefresh.  Our's correctly handles model
	 * changes for lists and tables.
	 * 
	 * @see org.eclipse.emf.edit.provider.INotifyChangedListener#notifyChanged(org.eclipse.emf.common.notify.Notification)
	 */
	public void notifyChanged(Notification notification) {
		if (viewer != null) {
			NotifyChangedToViewerRefresh.handleNotifyChanged(viewer,
					notification.getNotifier(), notification.getEventType(),
					notification.getFeature(), notification.getOldValue(),
					notification.getNewValue(), notification.getPosition());
		}
	}

}
