/*******************************************************************************
 * Copyright (c) 2006-2007 IONA Technologies.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *     IONA Technologies - initial API and implementation
 *******************************************************************************/
package org.eclipse.stp.ui.xef.editor;

import org.eclipse.swt.widgets.Spinner;

public class SpinnerControlAccessor implements ControlAccessor {
	private final Spinner spinner;
	
	public SpinnerControlAccessor(Spinner s) {
		spinner = s;
	}

	public String getValue() {
		return "" + spinner.getSelection();
	}

	public void setValue(String value) {
		try {
			if ("".equals(value)) {
				value = "0";
			}
			spinner.setSelection(Integer.parseInt(value));
		} catch (NumberFormatException e) {
			e.printStackTrace();
		}
	}

}
